package write

import (
	"errors"

	"git.tek.govt.hu/dowerx/place/api/structs"
	"git.tek.govt.hu/dowerx/place/auth"
	"git.tek.govt.hu/dowerx/place/config"
	"git.tek.govt.hu/dowerx/place/storage"
	"github.com/gin-gonic/gin"
)

var timeout int = config.GetConfig().Timeout

func Pixel(c *gin.Context) {
	var info struct {
		structs.Color
		structs.Coordinates
	}
	if c.ShouldBind(&info) != nil {
		c.AbortWithStatus(400)
		return
	}

	cookie, err := c.Cookie("place")
	if err != nil {
		cookie = auth.SetCookie(timeout)
		c.SetCookie("place", cookie, timeout, "/", "", false, false)
	} else {
		if auth.GetCookie(cookie) {
			c.Status(403)
			return
		}
	}

	if err := storage.SetPixel(info.X, info.Y, &info); err != nil {
		c.AbortWithError(500, err)
		return
	}

	c.Status(200)
}

func Bitmap(c *gin.Context) {
	panic(errors.New("unimplomented"))
}
